Index: webapp/cms/plugins/web/pages/services/resources/search.xsl
===================================================================
--- webapp/cms/plugins/web/pages/services/resources/search.xsl	(revision 9137)
+++ webapp/cms/plugins/web/pages/services/resources/search.xsl	(working copy)
@@ -44,12 +44,20 @@
 		
 			<body id="default">
 				
-				<div id="service-search-wrapper">
+				<div class="service service-search">
 					
 					<xsl:if test="$header != ''">
 						<h1><xsl:value-of select="$header"/></h1>
 					</xsl:if>
 					
+                    <xsl:if test="hits/hit and $on-same-page != 'true'">
+                        <div class="back">
+                            <a href="{$cms-context}/{url}" title="FRONT_MODULE_SEARCH_BACK_TO_SEARCH_TITLE" i18n:attr="title">
+                                <i18n:text i18n:key="FRONT_MODULE_SEARCH_BACK_TO_SEARCH"/>
+                            </a>
+                        </div>
+                    </xsl:if>                    
+                    
 					<form action="{$cms-context}/{/search/url}#nav" method="post" class="search">
 						<xsl:choose>
 							<xsl:when test="$on-same-page = 'true' or count(hits/hit) = 0">
@@ -59,9 +67,6 @@
 								<xsl:call-template name="form-search-hidden"/>
 							</xsl:otherwise>
 						</xsl:choose>
-						<xsl:if test="hits/hit and $on-same-page != 'true'">
-							<div class="back"><a href="{$cms-context}/{url}" title="FRONT_MODULE_SEARCH_BACK_TO_SEARCH_TITLE" i18n:attr="title"><i18n:text i18n:key="FRONT_MODULE_SEARCH_BACK_TO_SEARCH"/></a></div>
-						</xsl:if>
 							
 						<a name="nav"/>
 						
@@ -71,14 +76,12 @@
 					</form>	
 					
 					<xsl:choose>
-					
 						<xsl:when test="hits/hit">
 							<xsl:call-template name="hits"/>
-							
 							<xsl:call-template name="pagination"/>
 						</xsl:when>
 						<xsl:when test="/search/form/values and not(/search/illegal-textfield)">
-							<div class="no-result"><i18n:text i18n:key="FRONT_MODULE_SEARCH_NO_RESULT"/></div>
+							<p class="no-result"><i18n:text i18n:key="FRONT_MODULE_SEARCH_NO_RESULT"/></p>
 						</xsl:when>
 					</xsl:choose>
 					
@@ -92,27 +95,34 @@
 		 | Template for results
 		 + -->
 	<xsl:template name="hits">
-		
-		<dl class="search-hits">
-							
-			<xsl:for-each select="/search/hits/hit">
-				<dt class="hit resource">
-					<xsl:if test="position() mod 2 = 0"><xsl:attribute name="class">hit resource even</xsl:attribute></xsl:if>
-					<img class="icon" src="{$contextPath}/{icon}" alt=""/>
-					<a href="{$cms-context}/{uri}" title="{title}"><xsl:value-of select="title"/></a>
-					<span class="size"> <xsl:value-of select="size"/></span>
-				</dt>
-				<dd class="hit resource">	
-					<xsl:if test="position() mod 2 = 0"><xsl:attribute name="class">hit resource even</xsl:attribute></xsl:if>
-					<xsl:value-of select="excerpt"/>
-					<xsl:if test="/search/form/values/multisite">
-						<br/>
-						<span class="site"><xsl:value-of select="siteTitle"/><xsl:text> - </xsl:text><a href="{siteUrl}" target="_blank" title="{siteTitle}"><xsl:value-of select="siteUrl"/></a></span>
-					</xsl:if>
-				</dd>
-			</xsl:for-each>
-			
-		</dl>
+		<div class="results">
+            <ul>
+                <xsl:for-each select="/search/hits/hit">
+                    <li>
+                        <xsl:attribute name="class">resource
+                            <xsl:if test="position() mod 2 = 0"><xsl:text> even</xsl:text></xsl:if>                                
+                            <xsl:if test="position() = 1"><xsl:text> first</xsl:text></xsl:if>
+                            <xsl:if test="position() = last()"><xsl:text> last</xsl:text></xsl:if>                           
+                        </xsl:attribute>
+                        <div class="service-search-item">
+                            <img class="icon" src="{$contextPath}/{icon}" alt=""/>
+                            <a href="{$cms-context}/{uri}" title="{title}"><xsl:value-of select="title"/></a>
+                            <span class="size"> <xsl:value-of select="size"/></span>
+                        </div>
+                        <xsl:if test="excerpt">
+                            <div class="service-search-excerpt">
+                                <xsl:value-of select="excerpt"/>
+                            </div> 
+                        </xsl:if>
+                        <xsl:if test="/search/form/values/multisite">
+                            <div class="service-search-site">
+                                <p><xsl:value-of select="siteTitle"/><xsl:text> - </xsl:text><a href="{siteUrl}" target="_blank" title="{siteTitle}"><xsl:value-of select="siteUrl"/></a></p>
+                            </div>
+                        </xsl:if>                                                 
+                    </li>
+                </xsl:for-each>
+            </ul>
+        </div>
 	</xsl:template>	
 	
 	<!-- +
@@ -120,7 +130,7 @@
 		 + -->
 	<xsl:template name="results-sort">
 		<div class="results-sort">
-			<ul class="sort">
+			<ul>
 				<li><span><i18n:text i18n:key="FRONT_MODULE_SEARCH_SORT_BY"/></span></li>
 				<li>
 					<xsl:choose>
@@ -152,70 +162,68 @@
 		 + -->
 	<xsl:template name="pagination">
 		<form id="reload" method="post" action="{$cms-context}/{/search/url}#nav" accept-charset="UTF-8">
-			<div>
-                <input type="hidden" name="submit-form">
-                    <xsl:if test="/search/group-id and normalize-space(/search/group-id) != ''">
-                        <xsl:attribute name="value"><xsl:value-of select="/search/group-id"/></xsl:attribute>
-                    </xsl:if>
-                </input>
-                <xsl:if test="/search/zone-item/@id">
-                    <input type="hidden" name="zone-item-id" value="{/search/zone-item/@id}"/>
+            <input type="hidden" name="submit-form">
+                <xsl:if test="/search/group-id and normalize-space(/search/group-id) != ''">
+                    <xsl:attribute name="value"><xsl:value-of select="/search/group-id"/></xsl:attribute>
                 </xsl:if>
-                
-				<input type="hidden" name="textfield" value="{/search/form/values/textfield}"/>
-				<input type="hidden" name="offset" value="{/search/form/values/offset}"/>
-				<input type="hidden" name="start" value="{/search/form/values/start}"/>
-				
-				<!-- Creator -->
-				<xsl:for-each select="/search/form/values/creator">
-					<input type="hidden" name="dc_creator" value="{.}"/>
-				</xsl:for-each>
-		
-				<!-- Format -->
-				<xsl:for-each select="/search/form/values/format">
-					<input type="hidden" name="dc_format" value="{.}"/>
-				</xsl:for-each>
-						
-				<!-- Publisher -->
-				<xsl:for-each select="/search/form/values/publisher">
-					<input type="hidden" name="dc_publisher" value="{.}"/>
-				</xsl:for-each>
-				
-				<!-- Rights -->
-				<xsl:for-each select="/search/form/values/rights">
-					<input type="hidden" name="dc_rights" value="{.}"/>
-				</xsl:for-each>
-		
-				<!-- Page(s) -->
-				<xsl:choose>
-					<xsl:when test="count(/search/form/fields/pages/page) &gt;= 1">
-						<xsl:for-each select="/search/form/values/page">
-							<input type="hidden" name="pages" value="{.}"/>
-						</xsl:for-each>
-					</xsl:when>
-					<xsl:when test="count(/search/form/fields/pages/page) = 1">
-						<input type="hidden" name="pages" value="{/search/form/fields/pages/page/@path}"/>
-					</xsl:when>
-				</xsl:choose>
-		
-				<xsl:if test="/search/form/values/multisite">
-					<input type="hidden" name="multisite" value="true"/>
-					<xsl:for-each select="/search/form/values/site">
-						<input type="hidden" name="sites" value="{.}"/>
+            </input>
+            <xsl:if test="/search/zone-item/@id">
+                <input type="hidden" name="zone-item-id" value="{/search/zone-item/@id}"/>
+            </xsl:if>
+            
+			<input type="hidden" name="textfield" value="{/search/form/values/textfield}"/>
+			<input type="hidden" name="offset" value="{/search/form/values/offset}"/>
+			<input type="hidden" name="start" value="{/search/form/values/start}"/>
+			
+			<!-- Creator -->
+			<xsl:for-each select="/search/form/values/creator">
+				<input type="hidden" name="dc_creator" value="{.}"/>
+			</xsl:for-each>
+	
+			<!-- Format -->
+			<xsl:for-each select="/search/form/values/format">
+				<input type="hidden" name="dc_format" value="{.}"/>
+			</xsl:for-each>
+					
+			<!-- Publisher -->
+			<xsl:for-each select="/search/form/values/publisher">
+				<input type="hidden" name="dc_publisher" value="{.}"/>
+			</xsl:for-each>
+			
+			<!-- Rights -->
+			<xsl:for-each select="/search/form/values/rights">
+				<input type="hidden" name="dc_rights" value="{.}"/>
+			</xsl:for-each>
+	
+			<!-- Page(s) -->
+			<xsl:choose>
+				<xsl:when test="count(/search/form/fields/pages/page) &gt;= 1">
+					<xsl:for-each select="/search/form/values/page">
+						<input type="hidden" name="pages" value="{.}"/>
 					</xsl:for-each>
-				</xsl:if>
-				
-				<xsl:choose>
-					<xsl:when test="/search/sort-by-title-for-sorting">
-						<input type="hidden" name="sort-by-title-for-sorting"/>
-					</xsl:when>
-					<xsl:when test="/search/sort-by-date">
-						<input type="hidden" name="sort-by-date"/>
-					</xsl:when>
-					<xsl:otherwise>
-					</xsl:otherwise>
-				</xsl:choose>
-			</div>
+				</xsl:when>
+				<xsl:when test="count(/search/form/fields/pages/page) = 1">
+					<input type="hidden" name="pages" value="{/search/form/fields/pages/page/@path}"/>
+				</xsl:when>
+			</xsl:choose>
+	
+			<xsl:if test="/search/form/values/multisite">
+				<input type="hidden" name="multisite" value="true"/>
+				<xsl:for-each select="/search/form/values/site">
+					<input type="hidden" name="sites" value="{.}"/>
+				</xsl:for-each>
+			</xsl:if>
+			
+			<xsl:choose>
+				<xsl:when test="/search/sort-by-title-for-sorting">
+					<input type="hidden" name="sort-by-title-for-sorting"/>
+				</xsl:when>
+				<xsl:when test="/search/sort-by-date">
+					<input type="hidden" name="sort-by-date"/>
+				</xsl:when>
+				<xsl:otherwise>
+				</xsl:otherwise>
+			</xsl:choose>
 			
 			<div class="pagination">
 				
@@ -358,7 +366,6 @@
 				<div class="label"><label for="search-input-{$uniqueId}"><i18n:text i18n:key="FRONT_MODULE_SEARCH_KEYWORDS"/></label></div>
 				<div>
 					<input id="search-input-{$uniqueId}" type="text" name="textfield" value="{/search/form/values/textfield}"/>
-					<br/>
 					<xsl:if test="/search/illegal-textfield">
 						<span class="error"><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FRONT_SEARCH_INVALID_TEXTFIELD"/></span>
 					</xsl:if>
@@ -388,12 +395,11 @@
 									</option>
 								</xsl:for-each>
 							</select>
-							<br/>
 						</div>
 					</div>
 				</xsl:when>
 				<xsl:when test="count(/search/form/fields/pages/page) = 1">
-					<div><input type="hidden" name="pages" value="{/search/form/fields/pages/page/@path}"/></div>
+					<input type="hidden" name="pages" value="{/search/form/fields/pages/page/@path}"/>
 				</xsl:when>
 			</xsl:choose>
 			
@@ -403,7 +409,6 @@
 				<div class="label"><label for="creator-input-{$uniqueId}"><i18n:text i18n:key="FRONT_MODULE_SEARCH_CREATOR"/></label></div>
 				<div>
 					<input id="creator-input-{$uniqueId}" type="text" name="dc_creator" value="{/search/form/values/creator}"/>
-					<br/>
 					<xsl:if test="/search/illegal-textfield">
 						<span class="error"><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FRONT_SEARCH_INVALID_TEXTFIELD"/></span>
 					</xsl:if>
@@ -428,7 +433,6 @@
 								</option>
 							</xsl:for-each>
 						</select>
-						<br/>
 					</div>
 				</div>
 			</xsl:if>
@@ -472,7 +476,6 @@
 								</option>
 							</xsl:for-each>
 						</select>
-						<br/>
 					</div>
 				</div>
 			</xsl:if>
Index: webapp/cms/plugins/web/pages/services/filtered-contents/list.xsl
===================================================================
--- webapp/cms/plugins/web/pages/services/filtered-contents/list.xsl	(revision 9137)
+++ webapp/cms/plugins/web/pages/services/filtered-contents/list.xsl	(working copy)
@@ -21,135 +21,122 @@
                 xmlns:math="http://exslt.org/math"
                 exclude-result-prefixes="resolver math">
 
-	<xsl:import href="workspace:web://stylesheets/helper/html-hierarchy.xsl"/>
+    <xsl:import href="workspace:web://stylesheets/helper/html-hierarchy.xsl"/>
+    <xsl:import href="service:web://pages/services/common.xsl"/>
 
+    <!-- TODO -->
 	<xsl:param name="view"/>
+    <!-- TODO -->
 	<xsl:param name="service-title"/>
+    <!-- TODO -->
 	<xsl:param name="cms-context"/>
+    <!-- TODO -->
 	<xsl:param name="raw-context"/>
+    <!-- TODO -->
 	<xsl:param name="contextPath"/>
+    <!-- TODO -->
     <xsl:param name="skin"/>
+    <!-- TODO -->
 	<xsl:param name="link"/>
+    <!-- TODO -->
 	<xsl:param name="link-title"/>
+    <!-- TODO -->
 	<xsl:param name="pagination"/>
-	
-	<xsl:template match="/contents">
-		<xsl:variable name="contentsPerPage">
-			<xsl:choose>
-				<xsl:when test="$pagination = '' or $pagination = 0"><xsl:value-of select="count(content)"/></xsl:when>
-				<xsl:otherwise><xsl:value-of select="$pagination"/></xsl:otherwise>
-			</xsl:choose>
-		</xsl:variable>
-		<xsl:variable name="prefix">fc_<xsl:value-of select="substring-after(math:random(), '.')"/></xsl:variable>
+    
+    <!-- Used in common.xsl -->
+    <xsl:variable name="common-service-css-class-name">filtered-contents filtered-contents-<xsl:value-of select="$view"/></xsl:variable>
+    <xsl:variable name="is-empty" select="not(/contents/content)"/>
+    
+    <!-- TODO -->
+    <xsl:variable name="prefix">fc_<xsl:value-of select="substring-after(math:random(), '.')"/></xsl:variable>
 
-		<html>
-			<head>
-				<link href="{$contextPath}/plugins/web/resources/css/service/filtered-contents.css" type="text/css" rel="stylesheet" />
-			</head>
-			<body>
-				<xsl:if test="content">
-					<div class="content-list-wrapper {$view}">
-						
-						<xsl:if test="RSSFeedURL != ''">
-							<div class="rss">
-								<a href="{$raw-context}/{RSSFeedURL}"><img alt="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_RSS_FEED_ALT"  title="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_RSS_FEED" i18n:attr="title alt" src="{$contextPath}/plugins/web/resources/img/rss/feed.png"/></a>
-							</div>
-						</xsl:if>
-						
-						<xsl:if test="$service-title != ''">
-							<h1><xsl:value-of select="$service-title"/></h1>
-						</xsl:if>
+    <!-- TODO -->
+    <xsl:variable name="contentsPerPage">
+        <xsl:choose>
+            <xsl:when test="$pagination = '' or $pagination = 0"><xsl:value-of select="count(content)"/></xsl:when>
+            <xsl:otherwise><xsl:value-of select="$pagination"/></xsl:otherwise>
+        </xsl:choose>
+    </xsl:variable>
 
-						<script type="text/javascript">
-							<xsl:comment>
-								var pagination_<xsl:value-of select="$prefix"/> = [];
-							</xsl:comment>
-						</script>
-						
-						<xsl:call-template name="contents">
-							<xsl:with-param name="from" select="0"/>
-							<xsl:with-param name="by" select="$contentsPerPage"/>
-							<xsl:with-param name="prefix" select="$prefix"/>
-							<xsl:with-param name="count" select="1"/>
-						</xsl:call-template>						
 
-						<script type="text/javascript">
-								pagination_<xsl:value-of select="$prefix"/>_current = 0;	
-								if (pagination_<xsl:value-of select="$prefix"/>.length &gt; 1)
-								{
-									document.write("<![CDATA[<div class='pagination'><ul class='nav'><li>]]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES"/><![CDATA[</li><li id='content_filter_prev_]]><xsl:value-of select="$prefix"/><![CDATA[' style='display: none;' class='precede'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(\"prev\"); } catch(e) {} return false;' value=']]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES_PRECEDE"/><![CDATA['/></li>]]>");
-									for (var i = 0; i &lt; pagination_<xsl:value-of select="$prefix"/>.length; i++)
-									{
-										document.write("<![CDATA[<li id='content_filter_]]><xsl:value-of select="$prefix"/>" + i + "<![CDATA[_button' style='display: " + (i == 0 ? 'none' : '') + "' class='page'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(" + i + "); } catch(e) {} return false;' value='" + (i + 1) + "'/></li>]]>");
-										document.write("<![CDATA[<li id='content_filter_]]><xsl:value-of select="$prefix"/>" + i + "<![CDATA[' style='display: " + (i != 0 ? 'none' : '') + "' class='page'>" + (i + 1) + "</li>]]>");
-									}
-									document.write("<![CDATA[<li id='content_filter_next_]]><xsl:value-of select="$prefix"/><![CDATA[' class='next'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(\"next\"); } catch(e) {} return false;' value=']]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES_NEXT"/><![CDATA['/></li></ul></div><div style='clear: both;'></div>]]>");
-									
-									function show_<xsl:value-of select="$prefix"/>(count)
-									{
-										if (count == 'next')
-										{
-											count = pagination_<xsl:value-of select="$prefix"/>_current + 1;
-										}
-										else if (count == 'prev')
-										{
-											count = pagination_<xsl:value-of select="$prefix"/>_current - 1;
-										}
-									
-										for (var i = 0; i &lt; pagination_<xsl:value-of select="$prefix"/>.length; i++)
-										{
-											if (i == count)
-											{
-												document.getElementById('<xsl:value-of select="$prefix"/>-part-' + pagination_<xsl:value-of select="$prefix"/>[i]).style.display = "";
-												document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i + '_button').style.display = "none";
-												document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i).style.display = "";
-											}
-											else
-											{
-												document.getElementById('<xsl:value-of select="$prefix"/>-part-' + pagination_<xsl:value-of select="$prefix"/>[i]).style.display = "none";
-												document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i + '_button').style.display = "";
-												document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i).style.display = "none";
-											}
-										}
-										pagination_<xsl:value-of select="$prefix"/>_current = count;
+    <!-- +
+         | ROOT TEMPLATE
+         + -->    
+    <xsl:template match="/contents">
+         <xsl:call-template name="common-service"/> 
+    </xsl:template>
 
-										document.getElementById("content_filter_prev_<xsl:value-of select="$prefix"/>").style.display = (pagination_<xsl:value-of select="$prefix"/>_current == "0" ? 'none' : '');
-										document.getElementById("content_filter_next_<xsl:value-of select="$prefix"/>").style.display = (pagination_<xsl:value-of select="$prefix"/>_current == (pagination_<xsl:value-of select="$prefix"/>.length - 1) ? 'none' : '');
-									}
-								}
-						</script>
-						
-	                    <xsl:if test="starts-with($link, 'page://')">
-	                        <div class="link">
-	                            <a href="{resolver:resolve('page', $link)}">
-	                                <xsl:choose>
-	                                    <xsl:when test="normalize-space($link-title) != ''">
-	                                        <xsl:value-of select="$link-title"/>
-	                                    </xsl:when>
-	                                    <xsl:otherwise><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_LINK_TITLE_DEFAULT"/></xsl:otherwise>
-	                                </xsl:choose>
-	                            </a>
-	                        </div>
-	                    </xsl:if>
-					</div>
-				</xsl:if>
-			</body>
-		</html>
-	</xsl:template>
-	
+    <!-- +
+         | HEAD
+         + -->    
+
+    <!-- Used in common.xsl -->	
+    <xsl:template name="common-service-head-css">
+        <link href="{$contextPath}/plugins/web/resources/css/service/filtered-contents.css" type="text/css" rel="stylesheet" />
+    </xsl:template>
+    
+    <!-- +
+         | BODY
+         + -->    
+
+    <!-- Used in common.xsl --> 
+    <xsl:template name="common-service-body-nonempty-content">
+        <xsl:call-template name="rss"/>
+        
+        <xsl:call-template name="common-service-body-nonempty-content-title">
+            <xsl:with-param name="title" select="$service-title"/>
+        </xsl:call-template>
+
+        <xsl:call-template name="link-top"/>
+        
+        <xsl:call-template name="js-pagination-part"/>
+        
+        <xsl:call-template name="js-pagination-top"/>
+        
+        <xsl:call-template name="contents"/>
+
+        <xsl:call-template name="js-pagination-bottom"/>
+        
+        <xsl:call-template name="link-bottom"/>    
+    </xsl:template>    
+    
+    <xsl:template name="rss">
+        <xsl:if test="RSSFeedURL != ''">
+            <div class="rss">
+                <a href="{$raw-context}/{RSSFeedURL}">
+                    <img alt="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_RSS_FEED_ALT"  title="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_RSS_FEED" i18n:attr="title alt">
+                        <xsl:attribute name="src">
+                            <xsl:choose>
+                                <!-- TODO when helper to test resources in the skin -->
+<!--                                <xsl:when test="$skin/.."></xsl:when>-->
+                                <xsl:otherwise><xsl:value-of select="$contextPath"/>/plugins/web/resources/img/rss/feed.png</xsl:otherwise>
+                            </xsl:choose>
+                        </xsl:attribute>
+                    </img>
+                </a>
+            </div>
+        </xsl:if>    
+    </xsl:template>   
+            
+    <!-- TODO -->
 	<xsl:template match="content">
-		<div class="article">
-			<xsl:apply-templates select="html/body/node()" mode="move-hierarchy">
-				<xsl:with-param name="level" select="2"/>
-			</xsl:apply-templates>
+		<div>
+            <xsl:attribute name="class">article 
+                <xsl:if test="position() mod 2 = 0"><xsl:text> even</xsl:text></xsl:if>                                
+                <xsl:if test="position() = 1"><xsl:text> first</xsl:text></xsl:if>
+                <xsl:if test="position() = last()"><xsl:text> last</xsl:text></xsl:if>
+            </xsl:attribute>
+            <xsl:apply-templates select="html/body/node()" mode="move-hierarchy">
+                <xsl:with-param name="level" select="2"/>
+            </xsl:apply-templates>                           
 		</div>
 	</xsl:template>
 	
+    <!-- TODO -->
 	<xsl:template name="contents">
-		<xsl:param name="from"/>
-		<xsl:param name="by"/>
-		<xsl:param name="count"/>
-		<xsl:param name="prefix"/>
+		<xsl:param name="from" select="0"/>
+		<xsl:param name="by" select="$contentsPerPage"/>
+		<xsl:param name="count" select="1"/>
 	
 		<div id="{$prefix}-part-{$count}">
 			<script type="text/javascript">
@@ -169,10 +156,102 @@
 			<xsl:call-template name="contents">
 				<xsl:with-param name="from" select="$from + $by"/>
 				<xsl:with-param name="by" select="$by"/>
-				<xsl:with-param name="prefix" select="$prefix"/>
 				<xsl:with-param name="count" select="$count + 1"/>
 			</xsl:call-template>						
 		</xsl:if>
 	</xsl:template>
-	
+
+    <!-- TODO -->
+    <xsl:template name="js-pagination-part">
+        <script type="text/javascript">
+            <xsl:comment>
+                var pagination_<xsl:value-of select="$prefix"/> = [];
+            </xsl:comment>
+        </script>    
+    </xsl:template>
+    
+    <!-- TODO -->
+    <xsl:template name="js-pagination-top">
+        <xsl:comment>empty</xsl:comment>
+    </xsl:template>    
+
+    <!-- TODO -->
+    <xsl:template name="js-pagination-bottom">
+        <xsl:call-template name="js-pagination"/>
+    </xsl:template>
+    
+    <!-- TODO -->
+    <xsl:template name="js-pagination">
+        <script type="text/javascript">
+            pagination_<xsl:value-of select="$prefix"/>_current = 0;    
+            if (pagination_<xsl:value-of select="$prefix"/>.length &gt; 1)
+            {
+                document.write("<![CDATA[<div class='pagination'><ul class='nav'><li>]]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES"/><![CDATA[</li><li id='content_filter_prev_]]><xsl:value-of select="$prefix"/><![CDATA[' style='display: none;' class='precede'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(\"prev\"); } catch(e) {} return false;' value=']]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES_PRECEDE"/><![CDATA['/></li>]]>");
+                for (var i = 0; i &lt; pagination_<xsl:value-of select="$prefix"/>.length; i++)
+                {
+                    document.write("<![CDATA[<li id='content_filter_]]><xsl:value-of select="$prefix"/>" + i + "<![CDATA[_button' style='display: " + (i == 0 ? 'none' : '') + "' class='page'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(" + i + "); } catch(e) {} return false;' value='" + (i + 1) + "'/></li>]]>");
+                    document.write("<![CDATA[<li id='content_filter_]]><xsl:value-of select="$prefix"/>" + i + "<![CDATA[' style='display: " + (i != 0 ? 'none' : '') + "' class='page'>" + (i + 1) + "</li>]]>");
+                }
+                document.write("<![CDATA[<li id='content_filter_next_]]><xsl:value-of select="$prefix"/><![CDATA[' class='next'><input type='submit' onclick='try { show_]]><xsl:value-of select="$prefix"/><![CDATA[(\"next\"); } catch(e) {} return false;' value=']]><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_FRONT_PAGES_NEXT"/><![CDATA['/></li></ul></div><div style='clear: both;'></div>]]>");
+                
+                function show_<xsl:value-of select="$prefix"/>(count)
+                {
+                    if (count == 'next')
+                    {
+                        count = pagination_<xsl:value-of select="$prefix"/>_current + 1;
+                    }
+                    else if (count == 'prev')
+                    {
+                        count = pagination_<xsl:value-of select="$prefix"/>_current - 1;
+                    }
+                
+                    for (var i = 0; i &lt; pagination_<xsl:value-of select="$prefix"/>.length; i++)
+                    {
+                        if (i == count)
+                        {
+                            document.getElementById('<xsl:value-of select="$prefix"/>-part-' + pagination_<xsl:value-of select="$prefix"/>[i]).style.display = "";
+                            document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i + '_button').style.display = "none";
+                            document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i).style.display = "";
+                        }
+                        else
+                        {
+                            document.getElementById('<xsl:value-of select="$prefix"/>-part-' + pagination_<xsl:value-of select="$prefix"/>[i]).style.display = "none";
+                            document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i + '_button').style.display = "";
+                            document.getElementById('content_filter_<xsl:value-of select="$prefix"/>' + i).style.display = "none";
+                        }
+                    }
+                    pagination_<xsl:value-of select="$prefix"/>_current = count;
+
+                    document.getElementById("content_filter_prev_<xsl:value-of select="$prefix"/>").style.display = (pagination_<xsl:value-of select="$prefix"/>_current == "0" ? 'none' : '');
+                    document.getElementById("content_filter_next_<xsl:value-of select="$prefix"/>").style.display = (pagination_<xsl:value-of select="$prefix"/>_current == (pagination_<xsl:value-of select="$prefix"/>.length - 1) ? 'none' : '');
+                }
+            }
+        </script>      
+    </xsl:template>    
+  
+    <!-- TODO -->
+    <xsl:template name="link-top">
+        <xsl:comment>empty</xsl:comment>
+    </xsl:template>
+
+    <!-- TODO -->
+    <xsl:template name="link-bottom">
+        <xsl:call-template name="link"/>
+    </xsl:template>
+    
+    <!-- TODO -->
+	<xsl:template name="link">
+        <xsl:if test="starts-with($link, 'page://')">
+            <div class="link">
+                <a href="{resolver:resolve('page', $link)}">
+                    <xsl:choose>
+                        <xsl:when test="normalize-space($link-title) != ''">
+                            <xsl:value-of select="$link-title"/>
+                        </xsl:when>
+                        <xsl:otherwise><i18n:text i18n:key="PLUGINS_WEB_SERVICE_FILTERED_CONTENTS_LINK_TITLE_DEFAULT"/></xsl:otherwise>
+                    </xsl:choose>
+                </a>
+            </div>
+        </xsl:if>    
+    </xsl:template>
 </xsl:stylesheet>
